<template>
<st-content heading="Sesiones de Tutorías">
<st-tutor-appointment
        :key="componentKey"
        :info="sesion"
        v-model="dialog"
        @refresh="refresh"
/>
<div>
  <div class="content-body">

    <div class="table-heading">
      <v-row justify="start">
      <st-search
        text="Buscar por nombre de sesión de tutoría"
        @enter="search($event)"
      />
      <v-col md="4">
        <st-select
          nombre = "Estado de la sesión de tutoría"
          :items = "estados"
          itemText = nombre
          itemValue = nombre
          @cambioNombre="cambioPadre"
          :value = "estado"
        />
      </v-col>

    </v-row>
    </div>


    <!--<v-row>
      <v-col md="4">
      <st-date-picker
        nombre = "Periodo"
      />
      </v-col>
    </v-row>-->
     <v-data-table
    v-bind="{ headers,items }"
    :hide-default-footer="items.length <= 10"
    :loading="loading"
    loading-text="Cargando..."
    no-data-text="No se encontraron resultados"
    no-results-text="No se encontraron resultados"
    :sort-by="['fecha']"
    :sort-desc="[true]"
    :search="estado"
    :items-per-page="itemsPerPage"
  >
  <template
            v-slot:item.fecha="{ item }" >
    {{ item.fecha | formatDate }}
  </template>
  <template v-slot:item.actions="{ item }">
     <v-icon
      medium
      color= "primary"
      @click="details(item)"
      >mdi-clipboard-account
      </v-icon>


     <v-icon v-if= isvalid(item)
        medium
        color = "secondary"    
        @click="cancel(item)"
      >
        mdi-calendar-remove
      </v-icon>
      <v-icon v-else
        medium
        color = "primary"
        @click="open(item)"
      >
        mdi-calendar-text
      </v-icon>
    </template>
     </v-data-table>
  </div>
</div>
<v-row justify="center">
    <v-dialog v-model="dialog2" persistent max-width="400">
      <v-card>
         
        <v-card-title class="headline">{{ titulo }}</v-card-title>
        
        <v-card-text class="my-2">{{texto}}</v-card-text>
        
        <v-card-actions >
            <v-row no-gutters justify="end">
        <v-spacer></v-spacer> 

          <v-btn color="primary" text @click="dialog2 = false">Volver</v-btn>
          <v-btn v-if="positive" color="secondary" text>{{accion}}</v-btn>
          <v-btn v-else color="secondary" text @click="cancelApp">{{accion}}</v-btn>
            </v-row>
        </v-card-actions>

      </v-card>
    </v-dialog>
  </v-row>
</st-content>
</template>

<script>

import DataTable from '@/components/DataTable'
import Select from '@/components/Select'
import DatePicker from '@/components/DatePicker'
import Search from '@/components/Search'
import CitaTutor from '@/components/tutor/CitaTutor'
export default {
  data () {
    return{
      positive : true,
    dialog2: false,
    titulo : "",
    texto : "",
    accion:"",
      sesion : {
           alumno: {
                idAlumno: '',//"d9be5677-3791-4fa4-beda-4ff36ef19d62",
                nombre: 'Cargando...',//"Juan Alberto Quezada Ruiz",
                codigo: 'Cargando...',//"19993256",
                correo:'Cargando...',// "juan.quezada@pucp.edu.pe",
                unidad: {
                    idUnidad: '',//"73d40eb8-cbb8-4650-8e69-01c30c083b32",
                    nombre: 'Cargando...',//"Ingenier\u00eda Inform\u00e1tica"
                }
            },
            datos: {
                idSession: '',//"259f96d2-8ffc-45e3-bacc-be2484853ce3",
                nombreTutoria: 'Cargando...',//"Tutor\u00eda de Momento",
                numeroOrden: '0',//1,
                fechaInicio: null,//"2020-07-10T14:20:00+00:00",
                comentario: '',//null,
                idUnidadDerivada: null,//null,
                idEstado: 'Cargando...',//"Pendiente"
            },
            "planDeAccion": []
      },
      
      dialog:false,
      componentKey:0,
      item: {},
      itemsPerPage : 10,
      estado: 'Pendiente',
      items: [],
      estados: [],
      
      loading:false,
      idTutor : '80dd6af9-20f9-4099-98cb-fa2b1d167645',
      path:{
        url: '/tutor/tutorias/',
        id: 'idSession'
      },
      headers: [
        {
          text: 'Nombre de la tutoría',
          align: 'start',
          sortable: false,
          value: 'nombreTutoria',
        },
        {
          text: 'Alumno',
          sortable: false,
          value: 'alumno'
        },
        {
          text: 'Fecha y Hora de Inicio',
          value: 'fecha'
        },{
          text: 'Estado',
          value: 'estado'
        },
        {
          text: 'Acciones',
          value: 'actions',
          sortable: false,
          align: 'center'
        },
      ],
      filters:{
        search:'',
        estadoTut:'',
      }
    }
  },
  components: {
    'st-data-table' : DataTable,
    'st-select' : Select,
    'st-date-picker': DatePicker,
    'st-search': Search,
    'st-tutor-appointment':CitaTutor,
  },
  filters: {
    formatDate: function(value){
      if(!value) return "Cargando...";
      let options = { year: 'numeric', month: 'long', day: 'numeric', hour12: 'true',timeStyle: 'short', dateStyle: 'long'}
      let d = new Date(value).toLocaleTimeString('es', options)
      return d
    }
  },
  methods: {
    refresh(response){
      this.dialog=false;
      this.search('');
    },
    open(value){
      this.dialog=true
      this.componentKey += 1
      this.sesion = value
    },
    details(value){
      let path = this.path.url + value[this.path.id]
      this.$router.push(path)
    },
    imprimir(){
    },
    cambioPadre(dato){
      this.filters.estadoTut = dato;
      if(dato == "Todos") this.estado = "";
      else this.estado = dato;
    },
    async ini(){
      this.loading = true
      try {
        this.estados.push({nombre: 'Todos'})
        let { data: { data:{sesiones} } } = await this.$api.getTutorSessions(this.$store.state.role.id)
        let { data: {data: {estados}} } = await this.$api.getStatus()
        this.items = sesiones
        

        for (let it in estados){
          this.estados.push(estados[it])
        }
      } catch (error) {
        this.$store.commit("setError", error);
      }
      this.loading = false
    },
    async search(value){
      this.loading = true
      try {
        let { data: { data:{sesiones} } } = await this.$api.getTutorSessions(this.$store.state.role.id, value)
        this.items = sesiones
      } catch (error) {
        this.$store.commit("setError", error);
      }
      this.loading = false
    },
    addName(nombre){
      return 'XD :v'
    },
    isvalid(item){
      return item.estado === "Pendiente"
    },
    cancel(item){
        this.positive = false
        this.dialog2 = true
        this.titulo = "Cancelar cita"
        this.texto = "¿Está seguro de cancelar la cita? Recuerde que esto es un proceso irreversible."
        this.accion = "Cancelar cita"
        this.item = item
    },
    async cancelApp(){
         let data = {     
          "sesion":{
              "fechaInicio": this.item.fecha,//this.sesion.datos.fechaInicio, //Opcional
              "fechaFin":"",//new Date().toISOString().substr(0,19) + "-05:00",// "2020-07-10T15:00:00Z", //Opcional
              "comentario" : "",//this.aux.comentario,//"El alumno requiere soporte con algunos cursos", //Opcional
              "derivación": "",//true,//Opcional
              "idUnidadDerivada": "",//this.aux.derivacion,//"id-id-id-id", //Opcional
              "idEstado": "Cancelado"
            },
            "planDeAccion":  [],//this.aux.planDeAccion
      }
      try {
         let response = await this.$api.updateSession(this.item.idSession, data)
         this.ini()
        //this.$emit('refresh',{ response: response})
        
      } catch (e) {        
        this.$store.commit('setError', e)
      }
      this.dialog2 = false
    }


  },
  mounted () {
    this.ini()
    //window.addEventListener('keyup', (event) =>  {
    //  if (event.keyCode === 13) {
    //    this.imprimir()
    //  }
    //});
  },
  computed : {
  
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
